/*********************************************************************

   Copyright (C) 2002 Smaller Animals Software, Inc.

   This software is provided 'as-is', without any express or implied
   warranty.  In no event will the authors be held liable for any damages
   arising from the use of this software.

   Permission is granted to anyone to use this software for any purpose,
   including commercial applications, and to alter it and redistribute it
   freely, subject to the following restrictions:

   1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.

   2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.

   3. This notice may not be removed or altered from any source distribution.

   http://www.smalleranimals.com
   smallest@smalleranimals.com

**********************************************************************/

#if !defined(AFX_SASCREXCEPTION_H__24267BE6_7C47_11D5_93C1_0050DABB534C__INCLUDED_)
#define AFX_SASCREXCEPTION_H__24267BE6_7C47_11D5_93C1_0050DABB534C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSAScrException  
{
public:
   typedef enum{eParseNone, eParseSyntax, eParseSyntaxNonterm, eParseParameterCount, eParseInternal, eParseRecursionLimit, eParseUnknownSymbol} eParseError;

	CSAScrException();
	virtual ~CSAScrException();

   CSAScrException(eParseError e, const TCHAR *t) : m_eType(e), m_csText(t) {}

   // generate error text
   CSAString Text();
   
   CSAString   m_csText;
   eParseError m_eType;   
   
   static CSAString TranslateError(eParseError eError);
protected:
   
};

#endif // !defined(AFX_SASCREXCEPTION_H__24267BE6_7C47_11D5_93C1_0050DABB534C__INCLUDED_)