#ifndef BITSTREAM_H
#define BITSTREAM_H

#include "common.h"
#include "frame.h"
#include "args.h"
#include "DXHEAD.h"

// Maximum frame size
#define MAXFRAMESIZE 1792

unsigned long Currentms();
bool decode_header(unsigned long newhead, Frame *pfr);
bool Done_Stream();
void FillInputBuffer(int from = 0);
unsigned long Frame2ms();
void FreeInputBuffer();
extern unsigned long  __inline Get1Bit(void);
int GetBitrate(int lsf, int lay, int bi);
extern unsigned long __inline GetBits(int);
extern unsigned long __inline GetBitsFast(int);
static void GetLayer2(Frame *pfr);
bool GetNextFrame();
extern int GetXingHeader(XHEADDATA *X, unsigned char *buf);
bool head_read(unsigned char *hbuf, unsigned long *newhead);
bool Init_Stream();
bool InitInputBuffer();
bool ReadFrame(Frame *pfr, bool readBody = false);
bool ReadFrameBody(Frame *pfr);
void Reset_Stream();
bool Seek_Stream(int posInMs);
extern int SeekPoint(unsigned char TOC[100], int file_bytes, float percent);
void SetPointer(long);
unsigned long Totalms();

extern bool StreamInit;
extern unsigned char *wordpointer;

extern const long freqs[];

#endif